using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.StockCount.Cqrs;

public record DeleteStockCountItemCommand(string Id) : IRequest<bool>;

public class DeleteStockCountItemHandler : IRequestHandler<DeleteStockCountItemCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteStockCountItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteStockCountItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.InventoryTransaction.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}